[![npm version][npm-version-src]][npm-version-href]
[![npm downloads][npm-downloads-src]][npm-downloads-href]

<h1 align="center">Missing Native
	<img width="24" src="https://raw.githubusercontent.com/github/explore/80688e429a7d4ef2fca1e82350fe8e3517d3494d/topics/javascript/javascript.png" />
	Functions</h1>
<p align="center">A zero-dependecy JavaScript utility library delivering <b>missing</b> native functions 💼</p>

## Why use mnjsf?

mnjsf delivers functions missing from JavaScript

❯ 💼 **Zero-Dependency** Built without a dependency hell<br />
❯ 📐 **Lightweight** 2.5KB<br />
❯ 🌐 **NodeJS/Browser Support** use mnjsf in a browser or a Node.js application <br />
❯ ✨ **Direct Call** of utility functions on variables (`[].last()`) <br />

This library extends the properties of `Array`, `Object`, `Promise`, `Global`, `Math`, `Number` and `String`

## [Documentation](http://mnjsf.trantlabs.com/)

## Installation

```
npm i missing-native-js-functions
# or "yarn add missing-native-js-functions"
```

## Usage

ES5 import

```js
require("missing-native-js-functions");
```

ES6 import

```js
import "missing-native-js-functions";
```

use in Browser

```html
<script src="https://cdn.jsdelivr.net/npm/missing-native-js-functions/dist/mnjsf.min.js"></script>
```

## License

Made with 💚 Published under MIT License.

<!-- Badges -->

[npm-version-src]: https://flat.badgen.net/npm/v/missing-native-js-functions?style=flat-square&label=stable
[npm-version-href]: https://npmjs.com/package/missing-native-js-functions
[npm-downloads-src]: https://flat.badgen.net/npm/dm/missing-native-js-functions?style=flat-square&label=stable
[npm-downloads-href]: https://npmjs.com/package/missing-native-js-functions
